import { NgModule } from '@angular/core';

import { SharedLibsModule } from './shared-libs.module';
import { FindLanguageFromKeyPipe } from './language/find-language-from-key.pipe';
import { TranslateDirective } from './language/translate.directive';
import { AlertComponent } from './alert/alert.component';
import { AlertErrorComponent } from './alert/alert-error.component';
import { HasAnyAuthorityDirective } from './auth/has-any-authority.directive';
import { DurationPipe } from './date/duration.pipe';
import { FormatMediumDatetimePipe } from './date/format-medium-datetime.pipe';
import { FormatMediumDatePipe } from './date/format-medium-date.pipe';
import { SortByDirective } from './sort/sort-by.directive';
import { SortDirective } from './sort/sort.directive';
import { ItemCountComponent } from './pagination/item-count.component';
import { BookmarkToggleComponent } from './bookmark/bookmark-toggle.component';
import { MultiSelectDropdownExerciseComponent } from 'app/admin/review-management/multi-select-dropdown-exercise/multi-select-dropdown-exercise.component';
import { MultiSelectDropdownComponent } from 'app/admin/review-management/multi-select-dropdown/multi-select-dropdown.component';
import { FilterPipe } from 'app/admin/review-management/filter.pipe';
import { FilterEmailPipe } from 'app/admin/review-management/filterEmail.pipe';
import { ReviewHistoryComponent } from './review/review-history/review-history.component';
import { MatTableModule } from '@angular/material/table';

@NgModule({
  imports: [SharedLibsModule, MatTableModule],
  declarations: [
    FindLanguageFromKeyPipe,
    TranslateDirective,
    AlertComponent,
    AlertErrorComponent,
    HasAnyAuthorityDirective,
    DurationPipe,
    FormatMediumDatetimePipe,
    FormatMediumDatePipe,
    SortByDirective,
    SortDirective,
    ItemCountComponent,
    BookmarkToggleComponent,
    MultiSelectDropdownExerciseComponent,
    MultiSelectDropdownComponent,
    FilterPipe,
    FilterEmailPipe,
    ReviewHistoryComponent,
  ],
  exports: [
    SharedLibsModule,
    FindLanguageFromKeyPipe,
    TranslateDirective,
    AlertComponent,
    AlertErrorComponent,
    HasAnyAuthorityDirective,
    DurationPipe,
    FormatMediumDatetimePipe,
    FormatMediumDatePipe,
    SortByDirective,
    SortDirective,
    ItemCountComponent,
    BookmarkToggleComponent,
    MultiSelectDropdownExerciseComponent,
    MultiSelectDropdownComponent,
    FilterPipe,
    FilterEmailPipe,
    ReviewHistoryComponent,
  ],
  providers: [MultiSelectDropdownExerciseComponent],
})
export class SharedModule {}
