package at.ac.uibk.gitsearch.service.criteria;

import static org.assertj.core.api.Assertions.assertThat;

import at.ac.uibk.gitsearch.testingUtilities.PropertiesTester;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Test;
import tech.jhipster.service.filter.IntegerFilter;
import tech.jhipster.service.filter.LocalDateFilter;
import tech.jhipster.service.filter.LongFilter;
import tech.jhipster.service.filter.StringFilter;

class LikesCriteriaTest {

    @AfterEach
    void tearDown() throws Exception {}

    @Test
    void testWithPropertiesTester() {
        PropertiesTester pt = new PropertiesTester();

        pt.testProperties(LikesCriteria.class);
    }

    @Test
    void testProperties() {
        LikesCriteria lc = new LikesCriteria();
        LongFilter id = lc.id();
        LocalDateFilter date = lc.date();
        IntegerFilter userId = lc.userID();
        StringFilter exerciseId = lc.exerciseID();

        assertThat(lc.getId()).isEqualTo(id);
        assertThat(lc.getDate()).isEqualTo(date);
        assertThat(lc.getUserID()).isEqualTo(userId);
        assertThat(lc.getExerciseID()).isEqualTo(exerciseId);

        assertThat(lc.id()).isEqualTo(id);
        assertThat(lc.date()).isEqualTo(date);
        assertThat(lc.userID()).isEqualTo(userId);
        assertThat(lc.exerciseID()).isEqualTo(exerciseId);

        assertThat(lc.getDistinct()).isNull();
        lc.setDistinct(true);
        assertThat(lc.getDistinct()).isTrue();

        LikesCriteria lc2 = lc.copy();

        LongFilter lf = new LongFilter();
        IntegerFilter intf = new IntegerFilter();
        LocalDateFilter lfd = new LocalDateFilter();
        StringFilter sf = new StringFilter();

        lc2.setId(lf);
        lc2.setDate(lfd);
        lc2.setUserID(intf);
        lc2.setExerciseID(sf);

        assertThat(lc2.getId()).isEqualTo(lf);
        assertThat(lc2.getDate()).isEqualTo(lfd);
        assertThat(lc2.getUserID()).isEqualTo(intf);
        assertThat(lc2.getExerciseID()).isEqualTo(sf);

        assertThat(lc2.id()).isEqualTo(lf);
        assertThat(lc2.date()).isEqualTo(lfd);
        assertThat(lc2.userID()).isEqualTo(intf);
        assertThat(lc2.exerciseID()).isEqualTo(sf);
    }
}
